/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "tm_p.h"
#include "function.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "hard-reg-set.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"



/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.

   The third argument to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it
   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.c) to fill in the CLOBBERs.


   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/





static int
recog_1 (rtx x0 ATTRIBUTE_UNUSED,
	rtx insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x1 ATTRIBUTE_UNUSED;
  rtx x2 ATTRIBUTE_UNUSED;
  rtx x3 ATTRIBUTE_UNUSED;
  int tem ATTRIBUTE_UNUSED;

  x1 = XEXP (x0, 0);
  switch (GET_MODE (x1))
    {
    case SImode:
      goto L218;
    case QImode:
      goto L221;
    case HImode:
      goto L222;
    case CCmode:
      goto L223;
    default:
      break;
    }
 L102: ATTRIBUTE_UNUSED_LABEL
  if (GET_CODE (x1) == PC)
    goto L209;
  if (register_operand (x1, VOIDmode))
    {
      operands[0] = x1;
      goto L197;
    }
  goto ret0;

 L218: ATTRIBUTE_UNUSED_LABEL
  if (GET_CODE (x1) == MEM)
    goto L76;
  if (register_operand (x1, SImode))
    {
      operands[0] = x1;
      goto L3;
    }
 L219: ATTRIBUTE_UNUSED_LABEL
  if (register_operand (x1, SImode))
    {
      operands[1] = x1;
      goto L81;
    }
 L220: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_operand (x1, SImode))
    {
      operands[0] = x1;
      goto L86;
    }
  goto L102;

 L76: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode
      && GET_CODE (x2) == PRE_DEC)
    goto L77;
  goto L220;

 L77: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == SImode
      && GET_CODE (x3) == REG
      && XINT (x3, 0) == 1)
    goto L78;
  goto L220;

 L78: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (register_operand (x1, SImode))
    {
      operands[0] = x1;
      return 17;  /* movsi_push */
    }
  x1 = XEXP (x0, 0);
  goto L220;

 L3: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == SImode)
    goto L224;
  x1 = XEXP (x0, 0);
  goto L219;

 L224: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x1))
    {
    case PLUS:
      goto L4;
    case MINUS:
      goto L9;
    case MULT:
      goto L14;
    case DIV:
      goto L19;
    case UDIV:
      goto L24;
    case MOD:
      goto L29;
    case UMOD:
      goto L34;
    case NEG:
      goto L39;
    case NOT:
      goto L43;
    case AND:
      goto L47;
    case XOR:
      goto L52;
    case IOR:
      goto L57;
    case ASHIFT:
      goto L62;
    case ASHIFTRT:
      goto L67;
    case LSHIFTRT:
      goto L72;
    default:
     break;
   }
  x1 = XEXP (x0, 0);
  goto L219;

 L4: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L5;
    }
  x1 = XEXP (x0, 0);
  goto L219;

 L5: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (moxie_add_operand (x2, SImode))
    {
      operands[2] = x2;
      return 2;  /* addsi3 */
    }
  x1 = XEXP (x0, 0);
  goto L219;

 L9: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L10;
    }
  x1 = XEXP (x0, 0);
  goto L219;

 L10: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (moxie_sub_operand (x2, SImode))
    {
      operands[2] = x2;
      return 3;  /* subsi3 */
    }
  x1 = XEXP (x0, 0);
  goto L219;

 L14: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L15;
    }
  x1 = XEXP (x0, 0);
  goto L219;

 L15: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      operands[2] = x2;
      return 4;  /* mulsi3 */
    }
  x1 = XEXP (x0, 0);
  goto L219;

 L19: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L20;
    }
  x1 = XEXP (x0, 0);
  goto L219;

 L20: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      operands[2] = x2;
      return 5;  /* divsi3 */
    }
  x1 = XEXP (x0, 0);
  goto L219;

 L24: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L25;
    }
  x1 = XEXP (x0, 0);
  goto L219;

 L25: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      operands[2] = x2;
      return 6;  /* udivsi3 */
    }
  x1 = XEXP (x0, 0);
  goto L219;

 L29: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L30;
    }
  x1 = XEXP (x0, 0);
  goto L219;

 L30: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      operands[2] = x2;
      return 7;  /* modsi3 */
    }
  x1 = XEXP (x0, 0);
  goto L219;

 L34: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L35;
    }
  x1 = XEXP (x0, 0);
  goto L219;

 L35: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      operands[2] = x2;
      return 8;  /* umodsi3 */
    }
  x1 = XEXP (x0, 0);
  goto L219;

 L39: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      return 9;  /* negsi2 */
    }
  x1 = XEXP (x0, 0);
  goto L219;

 L43: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      return 10;  /* one_cmplsi2 */
    }
  x1 = XEXP (x0, 0);
  goto L219;

 L47: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L48;
    }
  x1 = XEXP (x0, 0);
  goto L219;

 L48: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      operands[2] = x2;
      return 11;  /* andsi3 */
    }
  x1 = XEXP (x0, 0);
  goto L219;

 L52: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L53;
    }
  x1 = XEXP (x0, 0);
  goto L219;

 L53: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      operands[2] = x2;
      return 12;  /* xorsi3 */
    }
  x1 = XEXP (x0, 0);
  goto L219;

 L57: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L58;
    }
  x1 = XEXP (x0, 0);
  goto L219;

 L58: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      operands[2] = x2;
      return 13;  /* iorsi3 */
    }
  x1 = XEXP (x0, 0);
  goto L219;

 L62: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L63;
    }
  x1 = XEXP (x0, 0);
  goto L219;

 L63: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      operands[2] = x2;
      return 14;  /* ashlsi3 */
    }
  x1 = XEXP (x0, 0);
  goto L219;

 L67: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L68;
    }
  x1 = XEXP (x0, 0);
  goto L219;

 L68: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      operands[2] = x2;
      return 15;  /* ashrsi3 */
    }
  x1 = XEXP (x0, 0);
  goto L219;

 L72: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L73;
    }
  x1 = XEXP (x0, 0);
  goto L219;

 L73: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      operands[2] = x2;
      return 16;  /* lshrsi3 */
    }
  x1 = XEXP (x0, 0);
  goto L219;

 L81: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == SImode
      && GET_CODE (x1) == MEM)
    goto L82;
  x1 = XEXP (x0, 0);
  goto L220;

 L82: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode
      && GET_CODE (x2) == POST_INC)
    goto L83;
  x1 = XEXP (x0, 0);
  goto L220;

 L83: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      operands[0] = x3;
      return 18;  /* movsi_pop */
    }
  x1 = XEXP (x0, 0);
  goto L220;

 L86: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (moxie_general_movsrc_operand (x1, SImode))
    {
      operands[1] = x1;
      goto L87;
    }
  x1 = XEXP (x0, 0);
  goto L102;

 L87: ATTRIBUTE_UNUSED_LABEL
  if (
#line 228 "../../gcc/config/moxie/moxie.md"
(register_operand (operands[0], SImode)
   || register_operand (operands[1], SImode)))
    {
      return 19;  /* *movsi */
    }
  x1 = XEXP (x0, 0);
  goto L102;

 L221: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_operand (x1, QImode))
    {
      operands[0] = x1;
      goto L90;
    }
  goto L102;

 L90: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (moxie_general_movsrc_operand (x1, QImode))
    {
      operands[1] = x1;
      goto L91;
    }
  x1 = XEXP (x0, 0);
  goto L102;

 L91: ATTRIBUTE_UNUSED_LABEL
  if (
#line 256 "../../gcc/config/moxie/moxie.md"
(register_operand (operands[0], QImode)
   || register_operand (operands[1], QImode)))
    {
      return 20;  /* *movqi */
    }
  x1 = XEXP (x0, 0);
  goto L102;

 L222: ATTRIBUTE_UNUSED_LABEL
  if (nonimmediate_operand (x1, HImode))
    {
      operands[0] = x1;
      goto L94;
    }
  goto L102;

 L94: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (moxie_general_movsrc_operand (x1, HImode))
    {
      operands[1] = x1;
      goto L95;
    }
  x1 = XEXP (x0, 0);
  goto L102;

 L95: ATTRIBUTE_UNUSED_LABEL
  if (
#line 284 "../../gcc/config/moxie/moxie.md"
((register_operand (operands[0], HImode)
    || register_operand (operands[1], HImode))))
    {
      return 21;  /* *movhi */
    }
  x1 = XEXP (x0, 0);
  goto L102;

 L223: ATTRIBUTE_UNUSED_LABEL
  if (GET_CODE (x1) == REG
      && XINT (x1, 0) == 11)
    goto L98;
  goto L102;

 L98: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_CODE (x1) == COMPARE)
    goto L99;
  x1 = XEXP (x0, 0);
  goto L102;

 L99: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[0] = x2;
      goto L100;
    }
  x1 = XEXP (x0, 0);
  goto L102;

 L100: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      return 22;  /* *cmpsi */
    }
  x1 = XEXP (x0, 0);
  goto L102;

 L209: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (nonimmediate_operand (x1, SImode))
    {
      operands[0] = x1;
      return 36;  /* indirect_jump */
    }
  switch (GET_CODE (x1))
    {
    case IF_THEN_ELSE:
      goto L104;
    case LABEL_REF:
      goto L213;
    default:
     break;
   }
  goto ret0;

 L104: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case NE:
      goto L105;
    case EQ:
      goto L114;
    case LT:
      goto L123;
    case LTU:
      goto L132;
    case GT:
      goto L141;
    case GTU:
      goto L150;
    case GE:
      goto L159;
    case LE:
      goto L168;
    case GEU:
      goto L177;
    case LEU:
      goto L186;
    default:
     break;
   }
  goto ret0;

 L105: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == CCmode
      && GET_CODE (x3) == REG
      && XINT (x3, 0) == 11)
    goto L106;
  goto ret0;

 L106: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (x3 == const_int_rtx[MAX_SAVED_CONST_INT + (0)])
    goto L107;
  goto ret0;

 L107: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == LABEL_REF)
    goto L108;
  goto ret0;

 L108: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L109;

 L109: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC)
    {
      return 23;  /* *bne */
    }
  goto ret0;

 L114: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == CCmode
      && GET_CODE (x3) == REG
      && XINT (x3, 0) == 11)
    goto L115;
  goto ret0;

 L115: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (x3 == const_int_rtx[MAX_SAVED_CONST_INT + (0)])
    goto L116;
  goto ret0;

 L116: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == LABEL_REF)
    goto L117;
  goto ret0;

 L117: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L118;

 L118: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC)
    {
      return 24;  /* *beq */
    }
  goto ret0;

 L123: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == CCmode
      && GET_CODE (x3) == REG
      && XINT (x3, 0) == 11)
    goto L124;
  goto ret0;

 L124: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (x3 == const_int_rtx[MAX_SAVED_CONST_INT + (0)])
    goto L125;
  goto ret0;

 L125: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == LABEL_REF)
    goto L126;
  goto ret0;

 L126: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L127;

 L127: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC)
    {
      return 25;  /* *blt */
    }
  goto ret0;

 L132: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == CCmode
      && GET_CODE (x3) == REG
      && XINT (x3, 0) == 11)
    goto L133;
  goto ret0;

 L133: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (x3 == const_int_rtx[MAX_SAVED_CONST_INT + (0)])
    goto L134;
  goto ret0;

 L134: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == LABEL_REF)
    goto L135;
  goto ret0;

 L135: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L136;

 L136: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC)
    {
      return 26;  /* *bltu */
    }
  goto ret0;

 L141: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == CCmode
      && GET_CODE (x3) == REG
      && XINT (x3, 0) == 11)
    goto L142;
  goto ret0;

 L142: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (x3 == const_int_rtx[MAX_SAVED_CONST_INT + (0)])
    goto L143;
  goto ret0;

 L143: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == LABEL_REF)
    goto L144;
  goto ret0;

 L144: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L145;

 L145: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC)
    {
      return 27;  /* *bgt */
    }
  goto ret0;

 L150: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == CCmode
      && GET_CODE (x3) == REG
      && XINT (x3, 0) == 11)
    goto L151;
  goto ret0;

 L151: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (x3 == const_int_rtx[MAX_SAVED_CONST_INT + (0)])
    goto L152;
  goto ret0;

 L152: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == LABEL_REF)
    goto L153;
  goto ret0;

 L153: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L154;

 L154: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC)
    {
      return 28;  /* *bgtu */
    }
  goto ret0;

 L159: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == CCmode
      && GET_CODE (x3) == REG
      && XINT (x3, 0) == 11)
    goto L160;
  goto ret0;

 L160: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (x3 == const_int_rtx[MAX_SAVED_CONST_INT + (0)])
    goto L161;
  goto ret0;

 L161: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == LABEL_REF)
    goto L162;
  goto ret0;

 L162: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L163;

 L163: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC)
    {
      return 29;  /* *bge */
    }
  goto ret0;

 L168: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == CCmode
      && GET_CODE (x3) == REG
      && XINT (x3, 0) == 11)
    goto L169;
  goto ret0;

 L169: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (x3 == const_int_rtx[MAX_SAVED_CONST_INT + (0)])
    goto L170;
  goto ret0;

 L170: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == LABEL_REF)
    goto L171;
  goto ret0;

 L171: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L172;

 L172: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC)
    {
      return 30;  /* *ble */
    }
  goto ret0;

 L177: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == CCmode
      && GET_CODE (x3) == REG
      && XINT (x3, 0) == 11)
    goto L178;
  goto ret0;

 L178: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (x3 == const_int_rtx[MAX_SAVED_CONST_INT + (0)])
    goto L179;
  goto ret0;

 L179: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == LABEL_REF)
    goto L180;
  goto ret0;

 L180: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L181;

 L181: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC)
    {
      return 31;  /* *bgeu */
    }
  goto ret0;

 L186: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == CCmode
      && GET_CODE (x3) == REG
      && XINT (x3, 0) == 11)
    goto L187;
  goto ret0;

 L187: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (x3 == const_int_rtx[MAX_SAVED_CONST_INT + (0)])
    goto L188;
  goto ret0;

 L188: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == LABEL_REF)
    goto L189;
  goto ret0;

 L189: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  goto L190;

 L190: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC)
    {
      return 32;  /* *bleu */
    }
  goto ret0;

 L213: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  return 37;  /* jump */

 L197: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_CODE (x1) == CALL)
    goto L198;
  goto ret0;

 L198: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == QImode
      && GET_CODE (x2) == MEM)
    goto L205;
  goto ret0;

 L205: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      operands[1] = x3;
      goto L206;
    }
  if (immediate_operand (x3, SImode))
    {
      operands[1] = x3;
      goto L200;
    }
  goto ret0;

 L206: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  return 35;  /* *call_value_indirect */

 L200: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  return 34;  /* *call_value */
 ret0:
  return -1;
}

int
recog (rtx x0 ATTRIBUTE_UNUSED,
	rtx insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x1 ATTRIBUTE_UNUSED;
  rtx x2 ATTRIBUTE_UNUSED;
  rtx x3 ATTRIBUTE_UNUSED;
  int tem ATTRIBUTE_UNUSED;
  recog_data.insn = NULL_RTX;

  switch (GET_CODE (x0))
    {
    case CONST_INT:
      goto L215;
    case SET:
      goto L2;
    case CALL:
      goto L192;
    case RETURN:
      goto L216;
    default:
     break;
   }
  goto ret0;

 L215: ATTRIBUTE_UNUSED_LABEL
  if (XWINT (x0, 0) == 0L)
    {
      return 1;  /* nop */
    }
  goto ret0;

 L2: ATTRIBUTE_UNUSED_LABEL
  return recog_1 (x0, insn, pnum_clobbers);

 L192: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 0);
  if (GET_MODE (x1) == QImode
      && GET_CODE (x1) == MEM)
    goto L193;
  goto ret0;

 L193: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (nonmemory_operand (x2, SImode))
    {
      operands[0] = x2;
      goto L194;
    }
  goto ret0;

 L194: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  operands[1] = x1;
  return 33;  /* *call */

 L216: ATTRIBUTE_UNUSED_LABEL
  if (
#line 449 "../../gcc/config/moxie/moxie.md"
(reload_completed))
    {
      return 38;  /* returner */
    }
  goto ret0;
 ret0:
  return -1;
}

rtx
split_insns (rtx x0 ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x1 ATTRIBUTE_UNUSED;
  rtx x2 ATTRIBUTE_UNUSED;
  rtx x3 ATTRIBUTE_UNUSED;
  rtx tem ATTRIBUTE_UNUSED;
  recog_data.insn = NULL_RTX;
  goto ret0;
 ret0:
  return 0;
}

